{**************************************}
{               WReboot                }
{        for Windows9x/NT/W2K          }
{       ~~~~~~~~~~~~~~~~~~~~~~         }
{             version 2.0              }
{                                      }
{                           05.05.2000 }
{**************************************}
{  1997,2000 by Sergey Kirichenko     }
{ email: ksv@cheerful.com              }
{**************************************}
program WReboot;


{$D-} // Debug information
{$L-} // Local symbols
{$Y-} // Reference
{$C-} // Assertions

uses windows;

{$R *.RES}
{$R ICONS.RES}

function isWinNT: boolean;
var
  osvi: TOSVERSIONINFO;
begin
  osvi.dwOSVersionInfoSize:= sizeof(TOSVERSIONINFO);
  GetVersionEx(osvi);
  result:= (osvi.dwPlatformId= VER_PLATFORM_WIN32_NT);
end;

function CompareText(const S1, S2: string): Integer; assembler;
asm
        PUSH    ESI
        PUSH    EDI
        PUSH    EBX
        MOV     ESI,EAX
        MOV     EDI,EDX
INC     ESI
INC     EDI
        OR      EAX,EAX
        JE      @@0
MOVZX   EAX,BYTE PTR [EAX]
{        MOV     EAX,[EAX-4]}
@@0:    OR      EDX,EDX
        JE      @@1
MOVZX   EDX,BYTE PTR [EDX]
{        MOV     EDX,[EDX-4]}
@@1:    MOV     ECX,EAX
        CMP     ECX,EDX
        JBE     @@2
        MOV     ECX,EDX
@@2:    CMP     ECX,ECX
@@3:    REPE    CMPSB
        JE      @@6
        MOV     BL,BYTE PTR [ESI-1]
        CMP     BL,'a'
        JB      @@4
        CMP     BL,'z'
        JA      @@4
        SUB     BL,20H
@@4:    MOV     BH,BYTE PTR [EDI-1]
        CMP     BH,'a'
        JB      @@5
        CMP     BH,'z'
        JA      @@5
        SUB     BH,20H
@@5:    CMP     BL,BH
        JE      @@3
        MOVZX   EAX,BL
        MOVZX   EDX,BH
@@6:    SUB     EAX,EDX
        POP     EBX
        POP     EDI
        POP     ESI
end;


{* start *}
var
  dwReserved: DWORD;
  uFlags:  UINT;
  hToken: THandle;
  tkp, tkDumb: TTokenPrivileges;
  DumbInt: dword;
  sParam: string;
begin
  uFlags:= 10;
  sParam:= paramStr(1);
  if CompareText(sParam,'FORCE')= 0 then
    uFlags:= EWX_FORCE
  else
    if CompareText(sParam,'LOGOFF')= 0 then
      uFlags:= EWX_LOGOFF
    else
      if CompareText(sParam,'POWEROFF')= 0 then
        uFlags:= EWX_POWEROFF
      else
        if CompareText(sParam,'REBOOT')= 0 then
          uFlags:= EWX_REBOOT
        else
          if CompareText(sParam,'SHUTDOWN')= 0 then
            uFlags:= EWX_SHUTDOWN;

  if uFlags<> 10 then
    begin
      if isWinNT then
        begin
          FillChar(tkp, sizeof(tkp), 0);
          // Get a token for this process
          if (OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken)) then
            begin
              // Get the LUID for the Shutdown privilege
              LookupPrivilegeValue(nil, pchar('SeShutdownPrivilege'), tkp.Privileges[0].Luid);
              tkp.PrivilegeCount:= 1; // one privilege to set
              tkp.Privileges[0].Attributes:= SE_PRIVILEGE_ENABLED;
              // Get the shutdown provolege for this process
              AdjustTokenPrivileges(hToken, false, tkp, sizeof(tkDumb), tkDumb, DumbInt);
            end;
          end;
      ExitWindowsEx(uFlags, 0)
    end
  else
    MessageBox(0,'usage: wreboot [FORCE | LOGOFF | POWEROFF | REBOOT | SHUTDOWN]',
      'WReboot 2.0,  2000 by Real Colonel (ksv@cheerful.com).',
      mb_OK+MB_ICONINFORMATION);
end.
